<?php
/**
 * montonio/module-hire-purchase
 *
 * @category   montonio
 * @package    module-hire-purchase
 * @copyright  Copyright (c) 2020 Montonio Finance OÜ  (https://montonio.com/)
 * @license    https://www.gnu.org/licenses/gpl-3.0.txt
 */
namespace Montonio\Hirepurchase\Model\Payment;

/**
 * Class SplitConfigProvider for providing config for hirepurchase
 */
class SplitConfigProvider implements \Magento\Checkout\Model\ConfigProviderInterface
{
    /**
     *
     * @var string
     */
    const CODE = 'montonio_split';

    /**
     * Credit card payment BIC code in lower case format.
     * @var string
     */
    public const CARD_PAYMENT_BIC = 'card';

    /**
     * Default sort order for method row.
     * @var int
     */
    public const DEFAULT_SORT_ORDER = 50;

    /**
     *
     * @param \Montonio\Hirepurchase\Gateway\Split\Config\Config $config
     * @param \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
     */
    public function __construct(
        \Montonio\Hirepurchase\Gateway\Split\Config\Config $config,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig
    ) {
        $this->config = $config;
        $this->scopeConfig = $scopeConfig;
    }

    /**
     * Retrieve assoc array of checkout configuration
     *
     * @return array
     */
    public function getConfig()
    {
        //this will be empty since we don't relay on it on frontend
        return $this->config->getConfig();
    }

    /**
     * Retrieve config object
     *
     * @return \Montonio\Hirepurchase\Gateway\Split\Config\Config
     */
    public function getConfigObject()
    {
        return $this->config;
    }
}
